// EJ18_01.CPP

// Este programa cuenta el nmero de comentarios estilo C++
// Es una modificacin de un programa similar de [FLA91]

#include <fstream>

const int TamLinea= 1024;                       // Longitud mxima de lnea.

void main(int argc, char *argv[]) {
  char c;
  int ContCom= 0,                               // Contador de comentarios
      CarCom= 0;                                // Nmero de caracteres en el comentario
  if (argc != 2) {
    cout << "\nNecesito un solo parmetro: el fichero a examinar";
    return;
  }

  ifstream fin(argv[1]);                        // El primer argumento es el fichero a examinar
  if (!fin) {
    cerr << "Error abriendo fichero de entrada"
         << argv[1] << '\n';
    return;
  }

  while	( (c = fin.get() ) != EOF) {
    if ((c == '/') && (fin.peek() == '/')) {    // Se ha encontrado un comentario?
      ContCom++;                                // Contarlo
      fin.ignore(TamLinea, '\n');               // Ignorar el resto de la lnea
      CarCom += fin.gcount();                   // Contar los caracteres del comentario.
      CarCom++;                                 // Incluir el primer '/'
    }
  }
  cout << ContCom << " comentarios encontrados, totalizando: ";
  cout << CarCom << " caracteres." << endl;
}